import IPart from "./IPart";
/**
 * Part
 */
declare abstract class AbstractPart implements IPart {
    readonly priority: number;
    protected _name: string;
    protected _type: string;
    protected _dom: Document;
    protected _parent: Map<string, IPart>;
    protected _options: Record<string, unknown>;
    protected _done: boolean;
    /**
     * Constructor
     * @param name
     * @param type
     * @param xml
     * @param parent
     * @param options
     * @protected
     */
    constructor(name: string, type: string, xml: string, parent: Map<string, IPart>, options: Record<string, unknown>);
    /**
     * name
     */
    get name(): string;
    /**
     * type
     */
    get type(): string;
    /**
     * done
     */
    get done(): boolean;
    /**
     * _preProcess
     * @param xml
     */
    protected _preProcess(xml: string): string;
    /**
     * render
     * @param data
     */
    abstract render(data: Record<string, unknown>): Promise<void>;
    /**
     * serialize
     */
    serialize(): string;
}
/**
 * Default export
 */
export default AbstractPart;
